﻿Public Class frmPad
    ' this form makes a window inside a MDI framework
    ' it is expected to hold a rich text box only
    Private Sub frmPad_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        frmPad_Resize(sender, e)
        rtxBox.AllowDrop = True
        frmTB.MH.Report = vbLf & Me.Text & " FormLoaded, "
    End Sub
    Private Sub frmPad_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        '' fudge factor
        With rtxBox
            .Top = 0
            .Left = 0
            .Width = Me.Width - 8
            .Height = Me.Height - PadMdiFrame.StatusStrip.Height - 5
        End With
        ScrollBars(rtxBox)
    End Sub
    Private Sub frmPad_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' don't let the user close the Scratchpad directly
        Const ms = "The text has changed. Do you want to save it," _
        & vbNewLine & "or cancel the closure?"
        Dim t As PadInfo = Me.Tag
        If Not t.Closeable Then
            If e.CloseReason = CloseReason.FormOwnerClosing Then Exit Sub
            e.Cancel = True
            Me.ParentForm.Visible = False
        End If
        If t.Ask And t.Changed Then
            Select Case MsgBox(ms, MsgBoxStyle.YesNoCancel, t.Name)
                Case MsgBoxResult.Yes
                    PadMdiFrame.SaveFile()
                Case MsgBoxResult.No
                Case MsgBoxResult.Cancel
                    e.Cancel = True
            End Select
        End If
    End Sub
    Private Sub frmPad_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp
        If e.KeyCode = Keys.F1 Then
            '' todo
            ' no help yet
        ElseIf e.Control Then
            Select Case e.KeyCode
                Case Keys.H
                    e.Handled = True
                    Me.ParentForm.Hide()
                Case Keys.L
                    e.Handled = True
                    ' look at selected tool's output
            End Select
        End If
    End Sub
    Private Sub rtxBox_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles rtxBox.DragDrop
        frmTB.MH.DragDrop(rtxBox, e)
    End Sub
    Private Sub rtxBox_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles rtxBox.DragEnter
        Dim r As RichTextBox = sender
        Dim n As String = r.Parent.Text
        frmTB.MH.DragEnter(n, e)
    End Sub
    Private Sub rtxArgs_DragLeave(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) _
    Handles rtxBox.DragLeave
        frmTB.MH.DragLeave()
    End Sub
    Private Sub rtxBox_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) _
Handles rtxBox.DragOver
        e.Effect = frmTB.MH.DragOver()
    End Sub
    'Private Sub rtxBox_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles rtxBox.GotFocus
    '    PadMdiFrame.Title(Me.Text)
    'End Sub
    Private Sub rtxBox_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles rtxBox.GotFocus
        frmTB.MH.GotFocus(sender, sender.Parent.Text)
    End Sub
    Private Sub rtxBox_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles rtxBox.KeyDown
        frmTB.MH.KeyDown(sender, e)
    End Sub
    Private Sub rtxBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles rtxBox.KeyPress
        frmTB.MH.KeyPress(sender, e)
    End Sub
    Private Sub rtxBox_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles rtxBox.KeyUp
        frmTB.MH.KeyUp(sender, e)
    End Sub
    Private Sub rtxBox_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles rtxBox.MouseDown
        'If e.Button = Windows.Forms.MouseButtons.Left Then
        '    frmTB.MH.MouseDown(rtxBox, e.X)
        'End If
        frmTB.MH.MouseDown(sender, e)
    End Sub
    Private Sub rtxBox_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles rtxBox.MouseEnter
        Dim r As RichTextBox = sender
        Dim n As String = r.Parent.Text
        frmTB.MH.MouseEnter(sender, n)
    End Sub
    Private Sub rtxBox_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles rtxBox.MouseLeave
        frmTB.MH.MouseLeave()
    End Sub
    Private Sub rtxBox_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles rtxBox.MouseMove
        frmTB.MH.MouseMove(rtxBox, e)
    End Sub
    Private Sub rtxBox_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles rtxBox.MouseUp
        If e.Button = Windows.Forms.MouseButtons.Left Then
            frmTB.MH.MouseUp()
        End If
    End Sub
    Private Sub rtxBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles rtxBox.TextChanged
        Dim t As PadInfo = Me.Tag
        t.Changed = True
        If t.Changed Then
            Me.Text = "*" & t.Name & "*"
        End If
        ScrollBars(sender)
    End Sub
    Private Sub ScrollBars(ByRef rtx As RichTextBox)
        With rtx
            If .TextLength < 2 Then Return
            Dim g As Graphics = rtx.CreateGraphics()
            Try
                If g.MeasureString(.Text, .Font).Height > .Size.Height Then
                    .ScrollBars = RichTextBoxScrollBars.ForcedVertical
                Else
                    .ScrollBars = RichTextBoxScrollBars.Both
                End If
            Catch ex As Exception
            Finally
                g.Dispose()
            End Try
        End With
    End Sub
End Class
