﻿Public Class PadInfo
    ' TBpad is designed to be stored in a form's tag but
    ' does not depend on this
    ' the form holds a rich text box only - designed for Scratchpad
    ' usage ...

    '   Dim frm = New Form
    '   frm.Hide()
    ' then
    '   frm.tag = New TBpad()       ' scratchpad
    ' or
    '   frm.tag = New TBpad(path)   ' path is the file loaded

    ' if _closeable is False, indicates a scratchpad - temporary jottings
    ' do not allow closure, do not save unless asked to
    ' set in New
    Private _scratch As Boolean = False  ' scratchpads can't be made dirty
    Private _ask As Boolean = True      ' force a save file dialogue
    Private _path As String = Nothing   ' filename for saving
    Private _closeable As Boolean = True ' don't close scratchpad
    Private _dirty = False  ' set when text has changed
    Public Sub New()
        ' use this version to indicate a scratchpad
        _scratch = True
        _path = GetTmpPath(True) & "scratchpad.txt"
        ' don't allow this form to be closed
        _closeable = False
    End Sub
    Public Sub New(ByVal path As String)
        ' use this version to indicate a closable form
        _path = path
    End Sub
    Public Sub New(ByVal b As Boolean)
        ' use this version to control closure
        ' b is true to be closable, false for not
        _closeable = b
        _path = ""
    End Sub
    Public Property Ask() As Boolean
        Get
            Return _ask
        End Get
        Set(ByVal value As Boolean)
            _ask = value
        End Set
    End Property
    Public ReadOnly Property Closeable() As Boolean
        Get
            Return _closeable
        End Get
    End Property
    Public Property Path() As String
        Get
            Return _path
        End Get
        Set(ByVal value As String)
            _path = value
        End Set
    End Property
    Public ReadOnly Property Name()
        Get
            Return System.IO.Path.GetFileName(_path)
        End Get
    End Property
    Public Property Changed()
        Get
            ' returns True if any changes have to be saved if
            ' they are not to be lost when closing this form
            Return _dirty
        End Get
        Set(ByVal value)
            ' scratchpads cannot have _dirty set to True
            _dirty = value And Not _scratch
        End Set
    End Property
    Public ReadOnly Property Scratch()
        Get
            Return _scratch
        End Get
    End Property
End Class
