﻿Imports System.Windows.Forms

Public Class PadMdiFrame
    Private m_ChildFormNumber As Integer = 0
    'Private _title As String = ""
    Private Sub ShowNewForm(ByVal sender As Object, ByVal e As EventArgs) _
    Handles NewToolStripMenuItem.Click, NewToolStripButton.Click, NewWindowToolStripMenuItem.Click
        ' Create a new Scratchpad child form
        m_ChildFormNumber += 1
        Dim s As String = "Window " & Str(m_ChildFormNumber)
        Dim f As frmPad = frmTB.MakeMdiChild(s, GetTmpPath(True) & s)
    End Sub
    Private Sub OpenFile(ByVal sender As Object, ByVal e As EventArgs) _
    Handles OpenToolStripButton.Click, OpenToolStripMenuItem.Click
        Dim frm As frmPad = Me.ActiveMdiChild
        Dim p As String = GetTmpPath(True)
        Dim s As String = GetOpenPath(p, True)
        If s <> "" Then
            Try
                frm.rtxBox.LoadFile(s, RichTextBoxStreamType.RichText)
            Catch
                Try
                    frm.rtxBox.LoadFile(s, RichTextBoxStreamType.PlainText)
                Catch ex As Exception
                    frmTB.ER.Display(ex, s)
                    Exit Sub
                End Try
            End Try
        End If
        Dim t As PadInfo = frm.Tag
        t.Changed = False
        t.Path = s
        If Not t.Scratch Then frm.Text = t.Name
        Exit Sub
    End Sub
    Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) _
    Handles SaveToolStripMenuItem.Click, SaveToolStripButton.Click
        SaveFile()
    End Sub
    Private Sub ExitToolsStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) _
    Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub
    Private Sub CutToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) _
    Handles CutToolStripMenuItem.Click
        Dim frm As frmPad = Me.ActiveMdiChild
        PadEdit.Cut(frm.rtxBox)
    End Sub
    Private Sub CopyToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CopyToolStripMenuItem.Click
        Dim frm As frmPad = Me.ActiveMdiChild
        PadEdit.Copy(frm.rtxBox)
    End Sub
    Private Sub PasteToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles PasteToolStripMenuItem.Click
        Dim frm As frmPad = Me.ActiveMdiChild
        PadEdit.Paste(frm.rtxBox)
    End Sub
    Private Sub ToolBarToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ToolBarToolStripMenuItem.Click
        Me.ToolStrip.Visible = Me.ToolBarToolStripMenuItem.Checked
    End Sub
    Private Sub StatusBarToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles StatusBarToolStripMenuItem.Click
        Me.StatusStrip.Visible = Me.StatusBarToolStripMenuItem.Checked
    End Sub
    Private Sub CascadeToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CascadeToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.Cascade)
    End Sub
    Private Sub TileVerticalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles TileVerticalToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.TileVertical)
    End Sub
    Private Sub TileHorizontalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles TileHorizontalToolStripMenuItem.Click
        Me.LayoutMdi(MdiLayout.TileHorizontal)
    End Sub
    Private Sub CloseAllToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CloseAllToolStripMenuItem.Click
        ' Close all child forms of the parent.
        For Each ChildForm As Form In Me.MdiChildren
            ChildForm.Close()
        Next
    End Sub
    Private Sub mdiPad_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' this is the MDI frame, not an actual window with contents
        ' don't let the user close it, only hide it
        If e.CloseReason = CloseReason.FormOwnerClosing Then Exit Sub
        e.Cancel = True
        Me.Hide()
    End Sub
    Private Sub mdiPad_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.stsStatus.Text = " "
        '_title = Me.Text
    End Sub
    Private Sub SelectAllToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SelectAllToolStripMenuItem.Click
        Dim frm As frmPad = Me.ActiveMdiChild
        frm.rtxBox.SelectAll()
    End Sub
    Public Sub SaveFile()
        Dim frm As frmPad = Me.ActiveMdiChild
        Dim tb As PadInfo = frm.Tag
        Dim s As String = vbNullString
        If tb.Path = vbNullString Then Exit Sub
        If tb.Ask Then
            s = GetSavePath(tb.Path, True)
            If s = vbNullString Then Exit Sub
        End If
        Dim type As Integer
        Select Case System.IO.Path.GetExtension(s)
            Case ".rtf"
                type = RichTextBoxStreamType.RichText
            Case ".txt"
                type = RichTextBoxStreamType.PlainText
            Case Else
                Const ss = "Invalid file extension: "
                frmTB.ER.Display(Nothing, ss & s)
                Exit Sub
        End Select
        Try
            frm.rtxBox.SaveFile(s, type)
            If Not tb.Scratch Then
                frm.Text = tb.Name
                tb.Changed = False
            End If
        Catch ex As Exception
            frmTB.ER.Display(ex, s)
        Finally
            frm.Text = tb.Name
        End Try
    End Sub
    '    Public Sub Title(ByVal name As String)
    '        If name Is Nothing Then
    '            _title = Me.Text
    '        ElseIf name = "" Then
    '            name = _title
    '        Else
    '            name = _title & " - [" & name & "]"
    '        End If
    '        Me.Text = name
    '    End Sub
End Class
