﻿''M2 11/08/2009 uses ItemData class for tools list, instead of TBini and Dictionary
''M3 20/10/2009 use Mouse class for own implementation of drag and drop
''M3 29/10/2009 in MH.MouseMove
Imports System.IO
Public Class frmTB
    Public ER As ErrorReporting ' setup error reporting
    Public MH As New Mouse  ' mouse handler
    Private Const license1 As String = "Copyright 2009 Don Skene. All rights reserved."
    Private Const Redistribution As String = "Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:"
    Private Const source As String = "   1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer."
    Private Const binary As String = "   2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution."
    Private Const nowarranty As String = "This software is provided 'AS IS' and any express or implied warranties, including, but not limited to, the implied warranties of merchantability and fitness for a particular purpose are disclaimed. In no event shall I or contributors be liable for any direct, indirect, incidental, special, exemplary, or consequential damages (including, but not limited to, procurement of substitute goods or services; loss of use, data, or profits; or business interruption) however caused and on any theory of liability, whether in contract, strict liability, or tort (including negligence or otherwise) arising in any way out of the use of this software, even if advised of the possibility of such damage."
    Private Sub frmToolbox_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        PadMdiFrame.Hide()
        ' once only: set up sctratchpad and error reporting
        ' scratchpad must be first child form
        ' and must be loaded before setting up error reporting
        Dim f As frmPad = MakeMdiChild("Scratchpad", Nothing)
        f.WindowState = FormWindowState.Maximized
        ER = New ErrorReporting ' setup error reporting
        Dim a = ""
        GetCommandLineArgs(a)
        If a.Length > 0 Then Me.rtxArgs.AppendText(a)
        btnTools_Click(sender, e)
        ' ensure there is a Tmp folder
        FindFiles(GetTmpPath(True))
        stsStatus.Text = " "
        rtxArgs.AllowDrop = True
    End Sub
    Public Sub StartDebug(ByVal yes As Boolean)
        If yes Then
            Try
                frmLog.Show()
            Catch ex As Exception
                stsStatus.Text = "Debugging not available"
            End Try
            Try
                MH.ReportTo = frmLog.rtx
            Catch ex As Exception
                stsStatus.Text = "Debugging not available"
            End Try
        Else
            MH.ReportTo = Nothing
            Try
                frmLog.Visible = False
            Catch ex As Exception
            End Try
        End If
    End Sub
    Private Sub frmToolbox_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.DoubleClick
        Try
            Dim r(2) As Single
            r(3) = 1    ' deliberate error
        Catch ex As Exception
            'ER.Display(ex, About())
            ER.Display(Nothing, About())
        End Try
    End Sub
    Private Function About() As String
        With My.Application.Info
            Dim version As String
            With .Version
                version = "Version " & .Major & "." & .Minor & "." & .MajorRevision & "." & .MinorRevision
            End With
            Return .Title & " - " & .Description & vbNewLine & vbNewLine _
            & version & vbNewLine & vbNewLine _
            & .Copyright & vbNewLine & vbNewLine & Redistribution & vbNewLine & vbNewLine & source _
            & vbNewLine & vbNewLine & binary & vbNewLine & vbNewLine & nowarranty & vbNewLine
        End With
    End Function
    Private Sub frmTB_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        If e.Alt Then
            Select Case e.KeyCode
                Case Keys.A
                    frmToolbox_DoubleClick(sender, e)
                    e.Handled = True
            End Select
        ElseIf e.Control Then
            Select Case e.KeyCode
                Case Keys.Delete
                    If rtxArgs.TextLength > 0 Then
                        rtxDeleted.Text = rtxArgs.Text
                        rtxArgs.Text = ""
                    End If
                    e.Handled = True
                Case Keys.Z
                    If rtxDeleted.TextLength > 0 Then
                        rtxArgs.Text = rtxDeleted.Text
                        rtxDeleted.Text = ""
                    End If
                    e.Handled = True
            End Select
        Else
            Select Case e.KeyCode
                Case Keys.F1
                    If lstTools.SelectedIndex < 0 Then
                        btnHelp_Click(sender, e)
                    Else
                        ToolHelp(lstTools)
                    End If
                    e.Handled = True
            End Select
        End If
    End Sub
    Public Function MakeMdiChild(ByVal name As String, ByVal path As String) As frmPad
        Dim frm As New frmPad
        With frm
            .Hide()
            .Text = name
            .MdiParent = PadMdiFrame
            If path Is Nothing Then
                ' scratchpad - TBpad controls closing and other behaviour
                .Tag = New PadInfo()
            Else
                .Tag = New PadInfo(path)
            End If
            .Name = name
            .Show()
        End With
        Return frm
    End Function
    Private Sub ToolHelp(ByRef lst As ListBox)
        With lst
            If .SelectedItems.Count = 1 Then
                Dim name As String = _
                    System.IO.Path.GetFileNameWithoutExtension(.SelectedItem.Name)
                Dim h As String = .SelectedItem.Help
                If Len(h) > 0 Then
                    ' help in ini file
                    Dim frm = MakeMdiChild(name, name)
                    frm.rtxBox.Text = h
                    Dim t As PadInfo = frm.Tag
                    t.Changed = False
                    't.Ask = False
                    frm.Text = t.Name
                    frm.Show()
                    PadMdiFrame.Show()
                    Exit Sub
                Else
                    ' search toolhelp folder
                    Const o = FileIO.SearchOption.SearchTopLevelOnly
                    With My.Computer.FileSystem
                        Dim folder As String = GetToolHelpPath(False)
                        If Not .DirectoryExists(folder) Then GoTo nohelp
                        For Each f In .GetFiles(GetToolHelpPath(False), o, name & ".*")
                            Dim frm = MakeMdiChild(name, f)
                            Try
                                frm.rtxBox.LoadFile(f, RichTextBoxStreamType.RichText)
                            Catch ex As Exception
                                Try
                                    frm.rtxBox.LoadFile(f, RichTextBoxStreamType.PlainText)
                                Catch exx As Exception
                                    ER.Display(exx, f)
                                End Try
                            End Try
                            Dim t As PadInfo = frm.Tag
                            t.Changed = False
                            frm.Text = t.Name
                            frm.Show()
                            PadMdiFrame.Show()
                            Exit Sub
                        Next
                    End With
nohelp:
                    stsStatus.Text = .SelectedItem.name & " has no help"
                End If
            End If
        End With
        Exit Sub
    End Sub
    Private Function GetTool(ByRef lst As ListBox) As String
        Dim tt As String = lst.SelectedItem.tool
        If Not My.Computer.FileSystem.FileExists(tt) Then
            stsStatus.Text = "Can't find " & tt
            tt = ""
        Else
            tt = Quoted(tt)
        End If
        Return tt
    End Function
    Private Function BuildArguements(ByRef tb As RichTextBox) As String
        Dim s As String, r As String = ""
        If tb.SelectionLength > 0 Then
            r = Replace(tb.SelectedText, vbLf, " ")
        Else
            For Each s In tb.Lines : r &= " " & s
            Next s
        End If
        Return Trim(r)
    End Function
    Private Function FileClean(ByVal s() As String) As String
        Return vbNullString
    End Function
    Private Sub RunTool(ByVal run As Boolean)
        Const keepopen As String = "cmd.exe /K "
        Const closecmd As String = "cmd.exe /C "
        If lstTools.SelectedIndex < 0 Then
            stsStatus.Text = "You must select a tool"
            Exit Sub
        End If
        Dim t As String = lstTools.SelectedItem.Tool
        If Not My.Computer.FileSystem.FileExists(t) Then
            stsStatus.Text = "Can't find " & t
            Exit Sub
        Else
            t = Quoted(t)
        End If
        If chkCmd.Checked Then
            t = If(chkKeep.Checked, keepopen & t, closecmd & t)
        End If
        stsStatus.Text = t
        t &= " " & BuildArguements(rtxArgs)
        Dim MyStyle As Integer = If(chkVisible.Checked, AppWinStyle.NormalFocus, AppWinStyle.Hide)
        If run Then
            Try
                stsStatus.Text &= " PID: " & CStr(Shell(t, Style:=MyStyle))
            Catch ex As Exception
                ER.Display(ex, t)
            End Try
        Else
            stsStatus.Text = t
        End If
    End Sub
    Private Sub lstTools_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstTools.DoubleClick
        btnRun_Click(sender, e)

    End Sub
    Private Sub lstTools_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles lstTools.KeyDown
        If e.KeyCode = Keys.Enter Then
            e.Handled = True
            btnRun_Click(sender, e)
        End If
    End Sub
    Private Sub lstTools_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstTools.SelectedIndexChanged
        Dim b As Boolean = lstTools.SelectedIndex >= 0
        btnName.Enabled = b
        btnRun.Enabled = b
        btnArgs.Enabled = b
        btnShow.Enabled = b
    End Sub
    Private Sub rtxArgs_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) _
    Handles rtxArgs.DragDrop
        MH.DragDrop(rtxArgs, e)
    End Sub
    Private Sub rtxArgs_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) _
    Handles rtxArgs.DragEnter
        MH.DragEnter("Args", e)
    End Sub
    Private Sub rtxArgs_DragLeave(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) _
    Handles rtxArgs.DragLeave
        MH.DragLeave()
    End Sub
    Private Sub rtxArgs_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) _
    Handles rtxArgs.DragOver
        e.Effect = MH.DragOver()
    End Sub
    Private Sub rtxArgs_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles rtxArgs.GotFocus
        MH.GotFocus(sender, "Args")
    End Sub
    Private Sub rtxArgs_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles rtxArgs.KeyDown
        MH.KeyDown(sender, e)
    End Sub
    Private Sub rtxArgs_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles rtxArgs.KeyPress
        MH.KeyPress(sender, e)
    End Sub
    'Private Sub rtxArgs_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles rtxArgs.KeyDown
    '    MH.KeyDown(rtxArgs, e)
    'End Sub
    'Private Sub rtxArgs_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles rtxArgs.KeyPress
    '    MH.KeyPress(rtxArgs, e)
    'End Sub
    Private Sub rtxArgs_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles rtxArgs.KeyUp
        MH.KeyUp(sender, e)
    End Sub
    Private Sub rtxArgs_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
    Handles rtxArgs.MouseDown
        MH.MouseDown(rtxArgs, e)
    End Sub
    Private Sub rtxArgs_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles rtxArgs.MouseEnter
        MH.MouseEnter(sender, "Args")
    End Sub
    Private Sub rtxArgs_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles rtxArgs.MouseLeave
        MH.MouseLeave()
    End Sub
    Private Sub rtxArgs_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
    Handles rtxArgs.MouseMove
        MH.MouseMove(rtxArgs, e)
    End Sub
    Private Sub rtxArgs_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
    Handles rtxArgs.MouseUp
        MH.MouseUp()
    End Sub
    Private Sub chkCmd_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkCmd.CheckedChanged
        chkKeep.Visible = chkCmd.Checked
        chkVisible.Visible = chkCmd.Checked
    End Sub
    Private Sub chkKeep_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkKeep.Click
        If chkKeep.Checked Then chkVisible.Checked = True
    End Sub
    Private Sub chkVisible_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkVisible.Click
        If Not chkVisible.Checked Then chkKeep.Checked = False
    End Sub
    Private Sub btnArgs_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnArgs.Click
        rtxArgs.SelectedText = lstTools.SelectedItem.Args
    End Sub
    Private Sub btnDebug_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDebug.Click
        With frmLog
            .Visible = Not .Visible
            If .Visible Then
                Try
                    frmLog.Show()
                Catch ex As Exception
                    stsStatus.Text = "Debugging not available"
                End Try
                Try
                    MH.ReportTo = frmLog.rtx
                Catch ex As Exception
                    stsStatus.Text = "Debugging not available"
                End Try
            End If
        End With
    End Sub
    Private Sub btnExit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub
    Private Sub btnHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHelp.Click
        Const htm As String = "index.htm"
        Const rtf As String = "ToolboxHelp.rtf"
        Const txt As String = "ToolboxHelp.txt"
        Const help As String = "Help from "
        Dim r As String = ""
        Dim folder As String = GetHelpPath(True)
        With My.Computer.FileSystem
            If Not .DirectoryExists(folder) Then
                stsStatus.Text = "No help available"
            ElseIf BrowserHelp(folder & htm) Then
                ' index.htm found
                stsStatus.Text = help & htm
            ElseIf TextHelp(folder & rtf) Then
                ' rtf file found
                stsStatus.Text = help & rtf
            ElseIf TextHelp(folder & txt) Then
                ' txt file found
                stsStatus.Text = help & txt
            Else
                stsStatus.Text = "No help available"
            End If
        End With
        Exit Sub
    End Sub
    Private Function BrowserHelp(ByVal file As String) As Boolean
        With My.Computer.FileSystem
            If Not .FileExists(file) Then
                stsStatus.Text = "No help file found"
                Return False
            End If
            Dim browser As String
            Dim ex As Exception
            Try
                ' http file found, find browser
                browser = GetBrowser(lstTools)
                If browser = "" Then
                    stsStatus.Text = "http help, but no browser found"
                    Return False
                Else
                    Shell(Quoted(browser) & " " & file, AppWinStyle.NormalFocus)
                End If
            Catch ex
                ER.Display(ex, file)
                stsStatus.Text ="Error running browser"
                Return False
            End Try
        End With
        Return True
    End Function
    Private Function TextHelp(ByVal file As String) As Boolean
        With My.Computer.FileSystem
            If Not .FileExists(file) Then Return False
            Dim ff As frmPad = My.Application.OpenForms().Item("ToolboxHelp")
            If ff Is Nothing Then
                ff = MakeMdiChild("ToolboxHelp", file)
            End If
            Try
                ff.rtxBox.LoadFile(file, RichTextBoxStreamType.RichText)
            Catch ex As Exception
                Try
                    ff.rtxBox.LoadFile(file, RichTextBoxStreamType.PlainText)
                Catch exx As Exception
                    ER.Display(exx, file)
                End Try
            End Try
            Dim t As PadInfo = ff.Tag
            t.Changed = False
            ff.Text = t.Name
            ff.Show()
            PadMdiFrame.Show()
            Return True
        End With
    End Function
    Private Sub btnName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnName.Click
        Dim s As String = System.IO.Path.GetFileNameWithoutExtension(lstTools.SelectedItem.Name)
        s = Quoted(GetTmpPath(True) & s & ".txt")
        ' don't duplicate the arguements
        If Not rtxArgs.Text.Contains(s) Then
            rtxArgs.SelectedText = s & vbNewLine
        End If
    End Sub
    Private Sub btnRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRun.Click
        If btnRun.Enabled Then RunTool(True)
    End Sub
    Private Sub btnScratchPad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnScratchPad.Click
        With PadMdiFrame
            .Visible = Not .Visible
            If .Visible Then
                .BringToFront()
            End If
        End With
    End Sub
    Private Sub btnTools_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTools.Click
        With lstTools.Items
            .Clear()
            ' find all the files in the Tools folder
            ' listing the name and extension
            For Each s In My.Computer.FileSystem.GetFiles(GetToolsPath(False))
                ' only use files with an extension
                Select Case System.IO.Path.GetExtension(s)
                    Case ""
                        ' no extension, ignore
                    Case Else
                        Dim t = New ItemData(s, System.IO.Path.GetFileName(s))
                        .Add(t)
                End Select
            Next
            If .Count > 0 Then
                lstTools.SelectedIndex = 0
                lstTools.Focus()
            End If
        End With
    End Sub
    Private Sub btnShow_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnShow.Click
        RunTool(False)
    End Sub
    Private Sub stsStatus_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles stsStatus.Paint
        ' use ER.Display if the width
        ' is too small to accomodate the string
        ' prevent multiple calls if the display window obscures the status box
        Static remember As String = ""
        Dim s = sender.ToString()
        If s <> remember Then
            remember = s
            Dim f As Font = stsStatus.Font
            Dim size As Single = stsStrip1.Size.Width
            If e.Graphics.MeasureString(s, f).Width > size Then
                ER.Display(Nothing, s)
            End If
        End If
    End Sub
End Class
